
/*****************************************************************************
 *                                                                           *
 *  PMB source code                                       ---/---            *
 *                                                          / /              *
 *  Copyright (c) Pallas GmbH 1998                         / / /             *
 *                                                        / / / /            *
 *                                                         / / /             *
 *  Author : Hans-Joachim Plum                              / / pallas       *
 *  Revision: 2.1                                         ---/---            *
 *  Date: 1998/09/03                                                         *
 *                                                                           *
 *****************************************************************************/

#include "declare.h"

void CPU_Exploit(float target_secs, int initialize)
{
/*
in: target_secs: desired runtime (about) of the current call
    initialize: 1/0 for first/following call with this value of target_secs
*/

#define SIZE 100
static float a[SIZE][SIZE], x[SIZE], y[SIZE];
double t1,t2;
static int Nrep, target_reps;
int i,j,repeat;

if( target_secs <= 0. ) return;

if( MFlops < 0. )
{
for(i=0; i< SIZE; i++)
  {
  x[i] = y[i] = 0.;
  for(j=0; j< SIZE; j++)
  a[i][j] = 1.;
  }
Nrep =  (50000000/(2*SIZE*SIZE))+1;
t1 = MPI_Wtime();
for( repeat=0; repeat<Nrep; repeat++) {
for (i=0; i<SIZE; i++)
    {
   for (j=0; j<SIZE; j++)
     x[i] = x[i] + a[i][j]*y[j];
    }
}
t2 = MPI_Wtime();

MFlops = (Nrep*2*SIZE*SIZE)*1.e-6/(t2-t1);
Nrep = (int)(1./(t2-t1)*Nrep);
target_reps = 0;

}

if( initialize )
{
target_reps = max(1,(int)(target_secs*Nrep));
t1 = MPI_Wtime();

for( repeat=0; repeat < target_reps; repeat++ )

for (i=0; i<SIZE; i++)
    {
   for (j=0; j<SIZE; j++)
     x[i] = x[i] + a[i][j]*y[j];
    }
t2 = MPI_Wtime();

tCPU = 1000000.*(t2-t1);
}
else
{
for( repeat=0; repeat < target_reps; repeat++ )

for (i=0; i<SIZE; i++)
    {
   for (j=0; j<SIZE; j++)
     x[i] = x[i] + a[i][j]*y[j];
    }
}

}
